/* LedControl_8x8_scroll
 *  
 * Fényújság 1 db MAX7219 meghajtóval vezérelt 8x8-as LED mátrixon.
 * Az inicializálás után előre megadott szöveget görgetünk a kijelzőn.
 * A MAX7219 vezérlése szofveres SPI meghajtással és a LedControl
 * programkönyvtár függvényeivel történik.
 */
#include "LedControl.h"
#include "english_6x8_pixel.h"

#define DATA_PIN    12        // MOSI -> DIN
#define CLOCK_PIN   11        // CLK  -> CLK
#define LOAD_PIN    10        // CS   -> LOAD
const char line1[] = "LedControl_8x8_scroll example program ";
// Proto: LedControl(int dataPin, int clkPin, int csPin, int numDevices=1);
LedControl lc=LedControl(DATA_PIN, CLOCK_PIN, LOAD_PIN, 1);

void setup() {
  delay(1000);
  pinMode(DATA_PIN,OUTPUT);
  pinMode(CLOCK_PIN,OUTPUT);
  pinMode(LOAD_PIN,OUTPUT);
  digitalWrite(LOAD_PIN,HIGH);
  lc.shutdown(0,false);
  lc.setIntensity(0,8);
  lc.clearDisplay(0);
}

void loop() {
  showText((char*)line1);
}

void scrollinRow(int data) {
  for(int r=0; r<7; r++) {
    lc.setRow(0,r,lc.getRow(0,r+1));
  }  
  lc.setRow(0,7,data);
}  

void writeChar(char ch) {
  ch -= 32;             //Start numbering from space
  for (int line=0; line<6; line++) {
    scrollinRow(font6x8[ch][line]); //write ont row
    delay(100);
  }
} 

void showText(const char *s) {
  while(*s) {
    writeChar(*s);
    s++;
  }  
}
